(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('apollo-link'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('apollo-angular-link-network-status', ['exports', '@angular/core', 'apollo-link', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global['apollo-angular-link-network-status'] = {}),global.ng.core,global.apolloLink.core,global.rxjs,global.rxjs.operators));
}(this, (function (exports,core,apolloLink,rxjs,operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @return {?}
     */
    function event() {
        return rxjs.pipe(operators.share(), operators.observeOn(rxjs.asyncScheduler));
    }
    var ApolloNetworkStatus = /** @class */ (function (_super) {
        __extends(ApolloNetworkStatus, _super);
        function ApolloNetworkStatus() {
            var _this = _super.call(this) || this;
            _this.count = 0;
            _this.pending$ = new rxjs.BehaviorSubject(false);
            _this.request$ = new rxjs.Subject();
            _this.success$ = new rxjs.Subject();
            _this.error$ = new rxjs.Subject();
            _this.cancel$ = new rxjs.Subject();
            _this.isPending = _this.pending$.asObservable().pipe(event(), operators.distinctUntilChanged());
            _this.onRequest = _this.request$.asObservable().pipe(event());
            _this.onSuccess = _this.success$.asObservable().pipe(event());
            _this.onError = _this.error$.asObservable().pipe(event());
            _this.onCancel = _this.cancel$.asObservable().pipe(event());
            return _this;
        }
        /**
         * @param {?} operation
         * @param {?} forward
         * @return {?}
         */
        ApolloNetworkStatus.prototype.request = /**
         * @param {?} operation
         * @param {?} forward
         * @return {?}
         */
            function (operation, forward) {
                var _this = this;
                this._onRequest({ operation: operation });
                /** @type {?} */
                var subscriber = forward(operation);
                return new apolloLink.Observable(function (observer) {
                    /** @type {?} */
                    var isPending = true;
                    /** @type {?} */
                    var subscription = subscriber.subscribe({
                        next: function (result) {
                            isPending = false;
                            _this._onSuccess({ operation: operation, result: result });
                            observer.next(result);
                        },
                        error: function (error) {
                            isPending = false;
                            _this._onError({ operation: operation, error: error });
                            observer.error(error);
                        },
                    });
                    return function () {
                        if (isPending)
                            _this._onCancel({ operation: operation });
                        if (subscription)
                            subscription.unsubscribe();
                    };
                });
            };
        /**
         * @param {?} data
         * @return {?}
         */
        ApolloNetworkStatus.prototype._onRequest = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                this.request$.next(data);
                this.increase();
            };
        /**
         * @param {?} data
         * @return {?}
         */
        ApolloNetworkStatus.prototype._onSuccess = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                this.success$.next(data);
                this.decrease();
            };
        /**
         * @param {?} data
         * @return {?}
         */
        ApolloNetworkStatus.prototype._onError = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                this.error$.next(data);
                this.decrease();
            };
        /**
         * @param {?} data
         * @return {?}
         */
        ApolloNetworkStatus.prototype._onCancel = /**
         * @param {?} data
         * @return {?}
         */
            function (data) {
                this.cancel$.next(data);
                this.decrease();
            };
        /**
         * @return {?}
         */
        ApolloNetworkStatus.prototype.increase = /**
         * @return {?}
         */
            function () {
                this.count++;
                this.update();
            };
        /**
         * @return {?}
         */
        ApolloNetworkStatus.prototype.decrease = /**
         * @return {?}
         */
            function () {
                this.count--;
                this.update();
            };
        /**
         * @return {?}
         */
        ApolloNetworkStatus.prototype.update = /**
         * @return {?}
         */
            function () {
                this.pending$.next(this.count > 0);
            };
        ApolloNetworkStatus.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ApolloNetworkStatus.ctorParameters = function () { return []; };
        return ApolloNetworkStatus;
    }(apolloLink.ApolloLink));
    var ApolloNetworkStatusModule = /** @class */ (function () {
        function ApolloNetworkStatusModule() {
        }
        ApolloNetworkStatusModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: [ApolloNetworkStatus],
                    },] }
        ];
        return ApolloNetworkStatusModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.event = event;
    exports.ApolloNetworkStatus = ApolloNetworkStatus;
    exports.ApolloNetworkStatusModule = ApolloNetworkStatusModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng.apollo-network-status.umd.js.map